<?php


namespace App\Models;

use App\Entities\CentroCusto\CentroCusto;
use App\Services\JWTService;
use App\Utils\DateUtils;
//use const False\MyClass\true;



class CentroCustoModel extends ModelEntity {
	protected $table = 'centro_custo';
	protected $primaryKey = 'id';
	protected $returnType = 'array';
	protected $allowedFields = [ 
			'descricao',
			'criado_em',
			'atualizado_em',
			'desativado_em',
			'criado_por',
			'alterado_por',
			'desativado_por'
	];
	protected $useSoftDeletes = false;
	protected $skipValidation = true;
	protected $useTimestamps = true;
	protected $createdField = 'criado_em';
	protected $updatedField = 'atualizado_em';

	public function registerCentroCusto(CentroCusto &$centro_custo): void {

		$centro_custo_data = $centro_custo->toArray();
		unset( $centro_custo_data ['id'] );
		unset( $centro_custo_data ['criado_em'] );
		unset( $centro_custo_data ['atualizado_em'] );
		$id_new_centro_custo = $this->insert( $centro_custo_data );
		$centro_custo->setId( $id_new_centro_custo );

	}

	public function updateCentroCustoByID(int $id_centro_custo, CentroCusto $centro_custo): bool {

		$data = $centro_custo->toArray( true );
		if (count( $data ) > 0) {
			$binds = [ 
					'id_centro_custo' => $id_centro_custo
			];
			$sql = "UPDATE centro_custo ";
			$sql .= $this->generateUpdateSets( $data, $binds );
			$sql .= 'WHERE centro_custo.id = :id_centro_custo:';
			$query = $this->db->query( $sql, $binds );
			$errors = $this->errors();
			return !$errors;
		} else {
			return true;
		}

	}

	public function deleteCentroCustoByID(int $id_centro_custo): bool {

		$jwt_payload = JWTService::getTokenJWTPayload();
		$uid = $jwt_payload ? $jwt_payload->getUid() : null;
		$today = DateUtils::today();

		$binds = [ 
				'desativado_por' => $uid,
				'desativado_em' => $today,
				'id_centro_custo' => $id_centro_custo
		];
		$sql = "UPDATE centro_custo SET desativado_por = :desativado_por: , desativado_em = :desativado_em: WHERE centro_custo.id = :id_centro_custo:";
		$query = $this->db->query( $sql, $binds );

		$errors = $this->errors();
		return !$errors;

	}

}
